﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using YamlDotNet.Serialization;
using YamlDotNet.Serialization.NamingConventions;


namespace GoitaViewer
{
    public partial class MainView : Form
    {
        public MainView()
        {
            InitializeComponent();

            labels.Add(new List<List<Label>>()); labels[0].Add(new List<Label>()); labels[0].Add(new List<Label>()); labels[0].Add(new List<Label>()); labels[0].Add(new List<Label>());
            labels.Add(new List<List<Label>>()); labels[1].Add(new List<Label>()); labels[1].Add(new List<Label>()); labels[1].Add(new List<Label>()); labels[1].Add(new List<Label>());
            labels.Add(new List<List<Label>>()); labels[2].Add(new List<Label>()); labels[2].Add(new List<Label>()); labels[2].Add(new List<Label>()); labels[2].Add(new List<Label>());
            labels.Add(new List<List<Label>>()); labels[3].Add(new List<Label>()); labels[3].Add(new List<Label>()); labels[3].Add(new List<Label>()); labels[3].Add(new List<Label>());
            labels[0][0].Add(koma111); labels[0][0].Add(koma112);
            labels[0][1].Add(koma121); labels[0][1].Add(koma122);
            labels[0][2].Add(koma131); labels[0][2].Add(koma132);
            labels[0][3].Add(koma141); labels[0][3].Add(koma142);

            labels[1][0].Add(koma211); labels[1][0].Add(koma212);
            labels[1][1].Add(koma221); labels[1][1].Add(koma222);
            labels[1][2].Add(koma231); labels[1][2].Add(koma232);
            labels[1][3].Add(koma241); labels[1][3].Add(koma242);

            labels[2][0].Add(koma311); labels[2][0].Add(koma312);
            labels[2][1].Add(koma321); labels[2][1].Add(koma322);
            labels[2][2].Add(koma331); labels[2][2].Add(koma332);
            labels[2][3].Add(koma341); labels[2][3].Add(koma342);

            labels[3][0].Add(koma411); labels[3][0].Add(koma412);
            labels[3][1].Add(koma421); labels[3][1].Add(koma422);
            labels[3][2].Add(koma431); labels[3][2].Add(koma432);
            labels[3][3].Add(koma441); labels[3][3].Add(koma442);
        }

        private string[] NumberToName = new string[] { "王", "飛", "角", "金", "銀", "馬", "香", "し" };

        private void load_Click(object sender, EventArgs e)
        {
            ofd.ShowDialog();

            using (var stream = ofd.OpenFile()) {
                if (stream == null) { return; }
                //内容を読み込み、表示する
                using (System.IO.StreamReader sr = new System.IO.StreamReader(stream))
                {
                    var deserializer = new Deserializer(namingConvention: new CamelCaseNamingConvention());
                    log = deserializer.Deserialize<GoitaLog>(sr);
                }
            }

            index = 0;
            step = 0;
            ShowGame();
        }

        private void SetHand(string hand, int player)
        {
            hands[player] = new List<string>();
            for (int i = 0; i < 8; ++i)
            {
               hands[player].Add(hand.Substring(i,1).Replace("玉","王"));
            }
        }

        private void ShowGame()
        {
            foreach(var l1 in labels)
            {
                foreach (var l2 in l1)
                {
                    foreach (var textbox in l2)
                    {
                        textbox.Text = "";
                    }
                }
            }

            GameLog game = log.Log[index];

            player1.Text = "P1: " + log.P0;
            player2.Text = "P2: " + log.P1;
            player3.Text = "P3: " + log.P2;
            player4.Text = "P4: " + log.P3;

            score1.Text = game.Score[0].ToString();
            score2.Text = game.Score[1].ToString();

            SetHand(game.Hand.P0, 0);
            SetHand(game.Hand.P1, 1);
            SetHand(game.Hand.P2, 2);
            SetHand(game.Hand.P3, 3);

            int[] player_steps = new int[4] { 0, 0, 0, 0};
            int last_player = game.Uchidashi;
            for(int i = 0; i < step; ++i)
            {
                List<string> info = game.Game[i];
                int player = Int32.Parse(info[0]);
                Color color1 = (player == last_player) ? Color.Blue : Color.Black;
                Label l1 = labels[player][player_steps[player]][0]; l1.ForeColor = color1     ; l1.Text = info[1]; hands[player].Remove(info[1]);
                Label l2 = labels[player][player_steps[player]][1]; l2.ForeColor = Color.Black; l2.Text = info[2]; hands[player].Remove(info[2]);
                ++player_steps[player];
                last_player = player;
            }

            for(int player = 0; player < 4; ++player)
            {
                int player_step = player_steps[player];
                for (int i = 0; i < 8 - player_step*2; i += 2)
                {
                    Label l1 = labels[player][i / 2 + player_step][0]; l1.ForeColor = Color.Gray; l1.Text = hands[player][i + 0];
                    Label l2 = labels[player][i / 2 + player_step][1]; l2.ForeColor = Color.Gray; l2.Text = hands[player][i + 1];
                }
            }
            
            if (game.Comment == null)
            {
                comment.Text = "";
            }
            else
            {
                comment.Text = game.Comment;
            }
        }

        private int index;
        private int step;

        private GoitaLog log;
        private List<List<List<Label>>> labels = new List<List<List<Label>>>();

        private List<string>[] hands = new List<string>[4];

        public class GoitaLog
        {
            public float Version { get; set; }
            //public DateTime Date { get; set; }
            public string P0 { get; set; }
            public string P1 { get; set; }
            public string P2 { get; set; }
            public string P3 { get; set; }
            //public string Date { get; set; }

            public List<GameLog> Log { get; set; }
        }
        public class Hand
        {
            public string P0 { get; set; }
            public string P1 { get; set; }
            public string P2 { get; set; }
            public string P3 { get; set; }
        }
        public class GameLog
        {
            public Hand Hand { get; set; }
            public int Uchidashi { get; set; }
            public List<int> Score { get; set; }
            public List<List<String>> Game { get; set; }
            public string Comment { get; set; }
        }

        private void prev_game_Click(object sender, EventArgs e)
        {
            --index;
            if (index < 0) { index = 0; }
            step = 0;
            ShowGame();
        }

        private void nextgame_Click(object sender, EventArgs e)
        {
            ++index;
            if (index > log.Log.Count - 1) { index = log.Log.Count - 1; }
            step = 0;
            ShowGame();
        }

        private void first_Click(object sender, EventArgs e)
        {
            step = 0;
            ShowGame();
        }

        private void last_Click(object sender, EventArgs e)
        {
            step = log.Log[index].Game.Count;
            ShowGame();
        }

        private void prev_Click(object sender, EventArgs e)
        {
            --step;
            if (step < 0) { step = 0; }
            ShowGame();
        }

        private void next_Click(object sender, EventArgs e)
        {
            ++step;
            if (step > log.Log[index].Game.Count) { step = log.Log[index].Game.Count; }
            ShowGame();
        }

        private void MainView_Load(object sender, EventArgs e)
        {

        }

        private void player1_Click(object sender, EventArgs e)
        {

        }

        private void player3_Click(object sender, EventArgs e)
        {

        }

        private void player2_Click(object sender, EventArgs e)
        {

        }

        private void player4_Click(object sender, EventArgs e)
        {

        }

        private void koma412_Click(object sender, EventArgs e)
        {

        }

        private void koma422_Click(object sender, EventArgs e)
        {

        }

        private void koma411_Click(object sender, EventArgs e)
        {

        }

        private void koma421_Click(object sender, EventArgs e)
        {

        }

        private void koma432_Click(object sender, EventArgs e)
        {

        }

        private void koma442_Click(object sender, EventArgs e)
        {

        }

        private void koma431_Click(object sender, EventArgs e)
        {

        }

        private void koma441_Click(object sender, EventArgs e)
        {

        }

        private void koma241_Click(object sender, EventArgs e)
        {

        }

        private void koma231_Click(object sender, EventArgs e)
        {

        }

        private void koma242_Click(object sender, EventArgs e)
        {

        }

        private void koma232_Click(object sender, EventArgs e)
        {

        }

        private void koma221_Click(object sender, EventArgs e)
        {

        }

        private void koma211_Click(object sender, EventArgs e)
        {

        }

        private void koma222_Click(object sender, EventArgs e)
        {

        }

        private void koma212_Click(object sender, EventArgs e)
        {

        }

        private void koma342_Click(object sender, EventArgs e)
        {

        }

        private void koma341_Click(object sender, EventArgs e)
        {

        }

        private void koma332_Click(object sender, EventArgs e)
        {

        }

        private void koma331_Click(object sender, EventArgs e)
        {

        }

        private void koma322_Click(object sender, EventArgs e)
        {

        }

        private void koma321_Click(object sender, EventArgs e)
        {

        }

        private void koma312_Click(object sender, EventArgs e)
        {

        }

        private void koma311_Click(object sender, EventArgs e)
        {

        }

        private void koma141_Click(object sender, EventArgs e)
        {

        }

        private void koma142_Click(object sender, EventArgs e)
        {

        }

        private void koma131_Click(object sender, EventArgs e)
        {

        }

        private void koma132_Click(object sender, EventArgs e)
        {

        }

        private void koma121_Click(object sender, EventArgs e)
        {

        }

        private void koma122_Click(object sender, EventArgs e)
        {

        }

        private void koma111_Click(object sender, EventArgs e)
        {

        }

        private void koma112_Click(object sender, EventArgs e)
        {

        }

        private void score2_Click(object sender, EventArgs e)
        {

        }

        private void score1_Click(object sender, EventArgs e)
        {

        }

        private void label2_Click(object sender, EventArgs e)
        {

        }

        private void label1_Click(object sender, EventArgs e)
        {

        }
    }
}
